package com.tanpu.fund.entity.generator;

import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

public class FundPerformanceExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public FundPerformanceExample() {
        oredCriteria = new ArrayList<>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        protected void addCriterionForJDBCDate(String condition, Date value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value.getTime()), property);
        }

        protected void addCriterionForJDBCDate(String condition, List<Date> values, String property) {
            if (values == null || values.size() == 0) {
                throw new RuntimeException("Value list for " + property + " cannot be null or empty");
            }
            List<java.sql.Date> dateList = new ArrayList<>();
            Iterator<Date> iter = values.iterator();
            while (iter.hasNext()) {
                dateList.add(new java.sql.Date(iter.next().getTime()));
            }
            addCriterion(condition, dateList, property);
        }

        protected void addCriterionForJDBCDate(String condition, Date value1, Date value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value1.getTime()), new java.sql.Date(value2.getTime()), property);
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Integer value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Integer value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Integer value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Integer value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Integer value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Integer> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Integer> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Integer value1, Integer value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Integer value1, Integer value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andPriceDateIsNull() {
            addCriterion("price_date is null");
            return (Criteria) this;
        }

        public Criteria andPriceDateIsNotNull() {
            addCriterion("price_date is not null");
            return (Criteria) this;
        }

        public Criteria andPriceDateEqualTo(Date value) {
            addCriterionForJDBCDate("price_date =", value, "priceDate");
            return (Criteria) this;
        }

        public Criteria andPriceDateNotEqualTo(Date value) {
            addCriterionForJDBCDate("price_date <>", value, "priceDate");
            return (Criteria) this;
        }

        public Criteria andPriceDateGreaterThan(Date value) {
            addCriterionForJDBCDate("price_date >", value, "priceDate");
            return (Criteria) this;
        }

        public Criteria andPriceDateGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("price_date >=", value, "priceDate");
            return (Criteria) this;
        }

        public Criteria andPriceDateLessThan(Date value) {
            addCriterionForJDBCDate("price_date <", value, "priceDate");
            return (Criteria) this;
        }

        public Criteria andPriceDateLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("price_date <=", value, "priceDate");
            return (Criteria) this;
        }

        public Criteria andPriceDateIn(List<Date> values) {
            addCriterionForJDBCDate("price_date in", values, "priceDate");
            return (Criteria) this;
        }

        public Criteria andPriceDateNotIn(List<Date> values) {
            addCriterionForJDBCDate("price_date not in", values, "priceDate");
            return (Criteria) this;
        }

        public Criteria andPriceDateBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("price_date between", value1, value2, "priceDate");
            return (Criteria) this;
        }

        public Criteria andPriceDateNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("price_date not between", value1, value2, "priceDate");
            return (Criteria) this;
        }

        public Criteria andFundIdIsNull() {
            addCriterion("fund_id is null");
            return (Criteria) this;
        }

        public Criteria andFundIdIsNotNull() {
            addCriterion("fund_id is not null");
            return (Criteria) this;
        }

        public Criteria andFundIdEqualTo(String value) {
            addCriterion("fund_id =", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdNotEqualTo(String value) {
            addCriterion("fund_id <>", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdGreaterThan(String value) {
            addCriterion("fund_id >", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdGreaterThanOrEqualTo(String value) {
            addCriterion("fund_id >=", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdLessThan(String value) {
            addCriterion("fund_id <", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdLessThanOrEqualTo(String value) {
            addCriterion("fund_id <=", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdLike(String value) {
            addCriterion("fund_id like", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdNotLike(String value) {
            addCriterion("fund_id not like", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdIn(List<String> values) {
            addCriterion("fund_id in", values, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdNotIn(List<String> values) {
            addCriterion("fund_id not in", values, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdBetween(String value1, String value2) {
            addCriterion("fund_id between", value1, value2, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdNotBetween(String value1, String value2) {
            addCriterion("fund_id not between", value1, value2, "fundId");
            return (Criteria) this;
        }

        public Criteria andEndDateIsNull() {
            addCriterion("end_date is null");
            return (Criteria) this;
        }

        public Criteria andEndDateIsNotNull() {
            addCriterion("end_date is not null");
            return (Criteria) this;
        }

        public Criteria andEndDateEqualTo(String value) {
            addCriterion("end_date =", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateNotEqualTo(String value) {
            addCriterion("end_date <>", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateGreaterThan(String value) {
            addCriterion("end_date >", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateGreaterThanOrEqualTo(String value) {
            addCriterion("end_date >=", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateLessThan(String value) {
            addCriterion("end_date <", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateLessThanOrEqualTo(String value) {
            addCriterion("end_date <=", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateLike(String value) {
            addCriterion("end_date like", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateNotLike(String value) {
            addCriterion("end_date not like", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateIn(List<String> values) {
            addCriterion("end_date in", values, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateNotIn(List<String> values) {
            addCriterion("end_date not in", values, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateBetween(String value1, String value2) {
            addCriterion("end_date between", value1, value2, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateNotBetween(String value1, String value2) {
            addCriterion("end_date not between", value1, value2, "endDate");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavIsNull() {
            addCriterion("cumulative_nav is null");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavIsNotNull() {
            addCriterion("cumulative_nav is not null");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavEqualTo(Double value) {
            addCriterion("cumulative_nav =", value, "cumulativeNav");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavNotEqualTo(Double value) {
            addCriterion("cumulative_nav <>", value, "cumulativeNav");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavGreaterThan(Double value) {
            addCriterion("cumulative_nav >", value, "cumulativeNav");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavGreaterThanOrEqualTo(Double value) {
            addCriterion("cumulative_nav >=", value, "cumulativeNav");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavLessThan(Double value) {
            addCriterion("cumulative_nav <", value, "cumulativeNav");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavLessThanOrEqualTo(Double value) {
            addCriterion("cumulative_nav <=", value, "cumulativeNav");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavIn(List<Double> values) {
            addCriterion("cumulative_nav in", values, "cumulativeNav");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavNotIn(List<Double> values) {
            addCriterion("cumulative_nav not in", values, "cumulativeNav");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavBetween(Double value1, Double value2) {
            addCriterion("cumulative_nav between", value1, value2, "cumulativeNav");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavNotBetween(Double value1, Double value2) {
            addCriterion("cumulative_nav not between", value1, value2, "cumulativeNav");
            return (Criteria) this;
        }

        public Criteria andRet1mIsNull() {
            addCriterion("ret_1m is null");
            return (Criteria) this;
        }

        public Criteria andRet1mIsNotNull() {
            addCriterion("ret_1m is not null");
            return (Criteria) this;
        }

        public Criteria andRet1mEqualTo(Double value) {
            addCriterion("ret_1m =", value, "ret1m");
            return (Criteria) this;
        }

        public Criteria andRet1mNotEqualTo(Double value) {
            addCriterion("ret_1m <>", value, "ret1m");
            return (Criteria) this;
        }

        public Criteria andRet1mGreaterThan(Double value) {
            addCriterion("ret_1m >", value, "ret1m");
            return (Criteria) this;
        }

        public Criteria andRet1mGreaterThanOrEqualTo(Double value) {
            addCriterion("ret_1m >=", value, "ret1m");
            return (Criteria) this;
        }

        public Criteria andRet1mLessThan(Double value) {
            addCriterion("ret_1m <", value, "ret1m");
            return (Criteria) this;
        }

        public Criteria andRet1mLessThanOrEqualTo(Double value) {
            addCriterion("ret_1m <=", value, "ret1m");
            return (Criteria) this;
        }

        public Criteria andRet1mIn(List<Double> values) {
            addCriterion("ret_1m in", values, "ret1m");
            return (Criteria) this;
        }

        public Criteria andRet1mNotIn(List<Double> values) {
            addCriterion("ret_1m not in", values, "ret1m");
            return (Criteria) this;
        }

        public Criteria andRet1mBetween(Double value1, Double value2) {
            addCriterion("ret_1m between", value1, value2, "ret1m");
            return (Criteria) this;
        }

        public Criteria andRet1mNotBetween(Double value1, Double value2) {
            addCriterion("ret_1m not between", value1, value2, "ret1m");
            return (Criteria) this;
        }

        public Criteria andRet1mBm1IsNull() {
            addCriterion("ret_1m_bm1 is null");
            return (Criteria) this;
        }

        public Criteria andRet1mBm1IsNotNull() {
            addCriterion("ret_1m_bm1 is not null");
            return (Criteria) this;
        }

        public Criteria andRet1mBm1EqualTo(Double value) {
            addCriterion("ret_1m_bm1 =", value, "ret1mBm1");
            return (Criteria) this;
        }

        public Criteria andRet1mBm1NotEqualTo(Double value) {
            addCriterion("ret_1m_bm1 <>", value, "ret1mBm1");
            return (Criteria) this;
        }

        public Criteria andRet1mBm1GreaterThan(Double value) {
            addCriterion("ret_1m_bm1 >", value, "ret1mBm1");
            return (Criteria) this;
        }

        public Criteria andRet1mBm1GreaterThanOrEqualTo(Double value) {
            addCriterion("ret_1m_bm1 >=", value, "ret1mBm1");
            return (Criteria) this;
        }

        public Criteria andRet1mBm1LessThan(Double value) {
            addCriterion("ret_1m_bm1 <", value, "ret1mBm1");
            return (Criteria) this;
        }

        public Criteria andRet1mBm1LessThanOrEqualTo(Double value) {
            addCriterion("ret_1m_bm1 <=", value, "ret1mBm1");
            return (Criteria) this;
        }

        public Criteria andRet1mBm1In(List<Double> values) {
            addCriterion("ret_1m_bm1 in", values, "ret1mBm1");
            return (Criteria) this;
        }

        public Criteria andRet1mBm1NotIn(List<Double> values) {
            addCriterion("ret_1m_bm1 not in", values, "ret1mBm1");
            return (Criteria) this;
        }

        public Criteria andRet1mBm1Between(Double value1, Double value2) {
            addCriterion("ret_1m_bm1 between", value1, value2, "ret1mBm1");
            return (Criteria) this;
        }

        public Criteria andRet1mBm1NotBetween(Double value1, Double value2) {
            addCriterion("ret_1m_bm1 not between", value1, value2, "ret1mBm1");
            return (Criteria) this;
        }

        public Criteria andRet3mIsNull() {
            addCriterion("ret_3m is null");
            return (Criteria) this;
        }

        public Criteria andRet3mIsNotNull() {
            addCriterion("ret_3m is not null");
            return (Criteria) this;
        }

        public Criteria andRet3mEqualTo(Double value) {
            addCriterion("ret_3m =", value, "ret3m");
            return (Criteria) this;
        }

        public Criteria andRet3mNotEqualTo(Double value) {
            addCriterion("ret_3m <>", value, "ret3m");
            return (Criteria) this;
        }

        public Criteria andRet3mGreaterThan(Double value) {
            addCriterion("ret_3m >", value, "ret3m");
            return (Criteria) this;
        }

        public Criteria andRet3mGreaterThanOrEqualTo(Double value) {
            addCriterion("ret_3m >=", value, "ret3m");
            return (Criteria) this;
        }

        public Criteria andRet3mLessThan(Double value) {
            addCriterion("ret_3m <", value, "ret3m");
            return (Criteria) this;
        }

        public Criteria andRet3mLessThanOrEqualTo(Double value) {
            addCriterion("ret_3m <=", value, "ret3m");
            return (Criteria) this;
        }

        public Criteria andRet3mIn(List<Double> values) {
            addCriterion("ret_3m in", values, "ret3m");
            return (Criteria) this;
        }

        public Criteria andRet3mNotIn(List<Double> values) {
            addCriterion("ret_3m not in", values, "ret3m");
            return (Criteria) this;
        }

        public Criteria andRet3mBetween(Double value1, Double value2) {
            addCriterion("ret_3m between", value1, value2, "ret3m");
            return (Criteria) this;
        }

        public Criteria andRet3mNotBetween(Double value1, Double value2) {
            addCriterion("ret_3m not between", value1, value2, "ret3m");
            return (Criteria) this;
        }

        public Criteria andRet3mBm1IsNull() {
            addCriterion("ret_3m_bm1 is null");
            return (Criteria) this;
        }

        public Criteria andRet3mBm1IsNotNull() {
            addCriterion("ret_3m_bm1 is not null");
            return (Criteria) this;
        }

        public Criteria andRet3mBm1EqualTo(Double value) {
            addCriterion("ret_3m_bm1 =", value, "ret3mBm1");
            return (Criteria) this;
        }

        public Criteria andRet3mBm1NotEqualTo(Double value) {
            addCriterion("ret_3m_bm1 <>", value, "ret3mBm1");
            return (Criteria) this;
        }

        public Criteria andRet3mBm1GreaterThan(Double value) {
            addCriterion("ret_3m_bm1 >", value, "ret3mBm1");
            return (Criteria) this;
        }

        public Criteria andRet3mBm1GreaterThanOrEqualTo(Double value) {
            addCriterion("ret_3m_bm1 >=", value, "ret3mBm1");
            return (Criteria) this;
        }

        public Criteria andRet3mBm1LessThan(Double value) {
            addCriterion("ret_3m_bm1 <", value, "ret3mBm1");
            return (Criteria) this;
        }

        public Criteria andRet3mBm1LessThanOrEqualTo(Double value) {
            addCriterion("ret_3m_bm1 <=", value, "ret3mBm1");
            return (Criteria) this;
        }

        public Criteria andRet3mBm1In(List<Double> values) {
            addCriterion("ret_3m_bm1 in", values, "ret3mBm1");
            return (Criteria) this;
        }

        public Criteria andRet3mBm1NotIn(List<Double> values) {
            addCriterion("ret_3m_bm1 not in", values, "ret3mBm1");
            return (Criteria) this;
        }

        public Criteria andRet3mBm1Between(Double value1, Double value2) {
            addCriterion("ret_3m_bm1 between", value1, value2, "ret3mBm1");
            return (Criteria) this;
        }

        public Criteria andRet3mBm1NotBetween(Double value1, Double value2) {
            addCriterion("ret_3m_bm1 not between", value1, value2, "ret3mBm1");
            return (Criteria) this;
        }

        public Criteria andRet6mIsNull() {
            addCriterion("ret_6m is null");
            return (Criteria) this;
        }

        public Criteria andRet6mIsNotNull() {
            addCriterion("ret_6m is not null");
            return (Criteria) this;
        }

        public Criteria andRet6mEqualTo(Double value) {
            addCriterion("ret_6m =", value, "ret6m");
            return (Criteria) this;
        }

        public Criteria andRet6mNotEqualTo(Double value) {
            addCriterion("ret_6m <>", value, "ret6m");
            return (Criteria) this;
        }

        public Criteria andRet6mGreaterThan(Double value) {
            addCriterion("ret_6m >", value, "ret6m");
            return (Criteria) this;
        }

        public Criteria andRet6mGreaterThanOrEqualTo(Double value) {
            addCriterion("ret_6m >=", value, "ret6m");
            return (Criteria) this;
        }

        public Criteria andRet6mLessThan(Double value) {
            addCriterion("ret_6m <", value, "ret6m");
            return (Criteria) this;
        }

        public Criteria andRet6mLessThanOrEqualTo(Double value) {
            addCriterion("ret_6m <=", value, "ret6m");
            return (Criteria) this;
        }

        public Criteria andRet6mIn(List<Double> values) {
            addCriterion("ret_6m in", values, "ret6m");
            return (Criteria) this;
        }

        public Criteria andRet6mNotIn(List<Double> values) {
            addCriterion("ret_6m not in", values, "ret6m");
            return (Criteria) this;
        }

        public Criteria andRet6mBetween(Double value1, Double value2) {
            addCriterion("ret_6m between", value1, value2, "ret6m");
            return (Criteria) this;
        }

        public Criteria andRet6mNotBetween(Double value1, Double value2) {
            addCriterion("ret_6m not between", value1, value2, "ret6m");
            return (Criteria) this;
        }

        public Criteria andRet6mBm1IsNull() {
            addCriterion("ret_6m_bm1 is null");
            return (Criteria) this;
        }

        public Criteria andRet6mBm1IsNotNull() {
            addCriterion("ret_6m_bm1 is not null");
            return (Criteria) this;
        }

        public Criteria andRet6mBm1EqualTo(Double value) {
            addCriterion("ret_6m_bm1 =", value, "ret6mBm1");
            return (Criteria) this;
        }

        public Criteria andRet6mBm1NotEqualTo(Double value) {
            addCriterion("ret_6m_bm1 <>", value, "ret6mBm1");
            return (Criteria) this;
        }

        public Criteria andRet6mBm1GreaterThan(Double value) {
            addCriterion("ret_6m_bm1 >", value, "ret6mBm1");
            return (Criteria) this;
        }

        public Criteria andRet6mBm1GreaterThanOrEqualTo(Double value) {
            addCriterion("ret_6m_bm1 >=", value, "ret6mBm1");
            return (Criteria) this;
        }

        public Criteria andRet6mBm1LessThan(Double value) {
            addCriterion("ret_6m_bm1 <", value, "ret6mBm1");
            return (Criteria) this;
        }

        public Criteria andRet6mBm1LessThanOrEqualTo(Double value) {
            addCriterion("ret_6m_bm1 <=", value, "ret6mBm1");
            return (Criteria) this;
        }

        public Criteria andRet6mBm1In(List<Double> values) {
            addCriterion("ret_6m_bm1 in", values, "ret6mBm1");
            return (Criteria) this;
        }

        public Criteria andRet6mBm1NotIn(List<Double> values) {
            addCriterion("ret_6m_bm1 not in", values, "ret6mBm1");
            return (Criteria) this;
        }

        public Criteria andRet6mBm1Between(Double value1, Double value2) {
            addCriterion("ret_6m_bm1 between", value1, value2, "ret6mBm1");
            return (Criteria) this;
        }

        public Criteria andRet6mBm1NotBetween(Double value1, Double value2) {
            addCriterion("ret_6m_bm1 not between", value1, value2, "ret6mBm1");
            return (Criteria) this;
        }

        public Criteria andRet1yIsNull() {
            addCriterion("ret_1y is null");
            return (Criteria) this;
        }

        public Criteria andRet1yIsNotNull() {
            addCriterion("ret_1y is not null");
            return (Criteria) this;
        }

        public Criteria andRet1yEqualTo(Double value) {
            addCriterion("ret_1y =", value, "ret1y");
            return (Criteria) this;
        }

        public Criteria andRet1yNotEqualTo(Double value) {
            addCriterion("ret_1y <>", value, "ret1y");
            return (Criteria) this;
        }

        public Criteria andRet1yGreaterThan(Double value) {
            addCriterion("ret_1y >", value, "ret1y");
            return (Criteria) this;
        }

        public Criteria andRet1yGreaterThanOrEqualTo(Double value) {
            addCriterion("ret_1y >=", value, "ret1y");
            return (Criteria) this;
        }

        public Criteria andRet1yLessThan(Double value) {
            addCriterion("ret_1y <", value, "ret1y");
            return (Criteria) this;
        }

        public Criteria andRet1yLessThanOrEqualTo(Double value) {
            addCriterion("ret_1y <=", value, "ret1y");
            return (Criteria) this;
        }

        public Criteria andRet1yIn(List<Double> values) {
            addCriterion("ret_1y in", values, "ret1y");
            return (Criteria) this;
        }

        public Criteria andRet1yNotIn(List<Double> values) {
            addCriterion("ret_1y not in", values, "ret1y");
            return (Criteria) this;
        }

        public Criteria andRet1yBetween(Double value1, Double value2) {
            addCriterion("ret_1y between", value1, value2, "ret1y");
            return (Criteria) this;
        }

        public Criteria andRet1yNotBetween(Double value1, Double value2) {
            addCriterion("ret_1y not between", value1, value2, "ret1y");
            return (Criteria) this;
        }

        public Criteria andRet1yBm1IsNull() {
            addCriterion("ret_1y_bm1 is null");
            return (Criteria) this;
        }

        public Criteria andRet1yBm1IsNotNull() {
            addCriterion("ret_1y_bm1 is not null");
            return (Criteria) this;
        }

        public Criteria andRet1yBm1EqualTo(Double value) {
            addCriterion("ret_1y_bm1 =", value, "ret1yBm1");
            return (Criteria) this;
        }

        public Criteria andRet1yBm1NotEqualTo(Double value) {
            addCriterion("ret_1y_bm1 <>", value, "ret1yBm1");
            return (Criteria) this;
        }

        public Criteria andRet1yBm1GreaterThan(Double value) {
            addCriterion("ret_1y_bm1 >", value, "ret1yBm1");
            return (Criteria) this;
        }

        public Criteria andRet1yBm1GreaterThanOrEqualTo(Double value) {
            addCriterion("ret_1y_bm1 >=", value, "ret1yBm1");
            return (Criteria) this;
        }

        public Criteria andRet1yBm1LessThan(Double value) {
            addCriterion("ret_1y_bm1 <", value, "ret1yBm1");
            return (Criteria) this;
        }

        public Criteria andRet1yBm1LessThanOrEqualTo(Double value) {
            addCriterion("ret_1y_bm1 <=", value, "ret1yBm1");
            return (Criteria) this;
        }

        public Criteria andRet1yBm1In(List<Double> values) {
            addCriterion("ret_1y_bm1 in", values, "ret1yBm1");
            return (Criteria) this;
        }

        public Criteria andRet1yBm1NotIn(List<Double> values) {
            addCriterion("ret_1y_bm1 not in", values, "ret1yBm1");
            return (Criteria) this;
        }

        public Criteria andRet1yBm1Between(Double value1, Double value2) {
            addCriterion("ret_1y_bm1 between", value1, value2, "ret1yBm1");
            return (Criteria) this;
        }

        public Criteria andRet1yBm1NotBetween(Double value1, Double value2) {
            addCriterion("ret_1y_bm1 not between", value1, value2, "ret1yBm1");
            return (Criteria) this;
        }

        public Criteria andRet2yIsNull() {
            addCriterion("ret_2y is null");
            return (Criteria) this;
        }

        public Criteria andRet2yIsNotNull() {
            addCriterion("ret_2y is not null");
            return (Criteria) this;
        }

        public Criteria andRet2yEqualTo(Double value) {
            addCriterion("ret_2y =", value, "ret2y");
            return (Criteria) this;
        }

        public Criteria andRet2yNotEqualTo(Double value) {
            addCriterion("ret_2y <>", value, "ret2y");
            return (Criteria) this;
        }

        public Criteria andRet2yGreaterThan(Double value) {
            addCriterion("ret_2y >", value, "ret2y");
            return (Criteria) this;
        }

        public Criteria andRet2yGreaterThanOrEqualTo(Double value) {
            addCriterion("ret_2y >=", value, "ret2y");
            return (Criteria) this;
        }

        public Criteria andRet2yLessThan(Double value) {
            addCriterion("ret_2y <", value, "ret2y");
            return (Criteria) this;
        }

        public Criteria andRet2yLessThanOrEqualTo(Double value) {
            addCriterion("ret_2y <=", value, "ret2y");
            return (Criteria) this;
        }

        public Criteria andRet2yIn(List<Double> values) {
            addCriterion("ret_2y in", values, "ret2y");
            return (Criteria) this;
        }

        public Criteria andRet2yNotIn(List<Double> values) {
            addCriterion("ret_2y not in", values, "ret2y");
            return (Criteria) this;
        }

        public Criteria andRet2yBetween(Double value1, Double value2) {
            addCriterion("ret_2y between", value1, value2, "ret2y");
            return (Criteria) this;
        }

        public Criteria andRet2yNotBetween(Double value1, Double value2) {
            addCriterion("ret_2y not between", value1, value2, "ret2y");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1IsNull() {
            addCriterion("ret_2y_bm1 is null");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1IsNotNull() {
            addCriterion("ret_2y_bm1 is not null");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1EqualTo(Double value) {
            addCriterion("ret_2y_bm1 =", value, "ret2yBm1");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1NotEqualTo(Double value) {
            addCriterion("ret_2y_bm1 <>", value, "ret2yBm1");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1GreaterThan(Double value) {
            addCriterion("ret_2y_bm1 >", value, "ret2yBm1");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1GreaterThanOrEqualTo(Double value) {
            addCriterion("ret_2y_bm1 >=", value, "ret2yBm1");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1LessThan(Double value) {
            addCriterion("ret_2y_bm1 <", value, "ret2yBm1");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1LessThanOrEqualTo(Double value) {
            addCriterion("ret_2y_bm1 <=", value, "ret2yBm1");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1In(List<Double> values) {
            addCriterion("ret_2y_bm1 in", values, "ret2yBm1");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1NotIn(List<Double> values) {
            addCriterion("ret_2y_bm1 not in", values, "ret2yBm1");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1Between(Double value1, Double value2) {
            addCriterion("ret_2y_bm1 between", value1, value2, "ret2yBm1");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1NotBetween(Double value1, Double value2) {
            addCriterion("ret_2y_bm1 not between", value1, value2, "ret2yBm1");
            return (Criteria) this;
        }

        public Criteria andRet2yAIsNull() {
            addCriterion("ret_2y_a is null");
            return (Criteria) this;
        }

        public Criteria andRet2yAIsNotNull() {
            addCriterion("ret_2y_a is not null");
            return (Criteria) this;
        }

        public Criteria andRet2yAEqualTo(Double value) {
            addCriterion("ret_2y_a =", value, "ret2yA");
            return (Criteria) this;
        }

        public Criteria andRet2yANotEqualTo(Double value) {
            addCriterion("ret_2y_a <>", value, "ret2yA");
            return (Criteria) this;
        }

        public Criteria andRet2yAGreaterThan(Double value) {
            addCriterion("ret_2y_a >", value, "ret2yA");
            return (Criteria) this;
        }

        public Criteria andRet2yAGreaterThanOrEqualTo(Double value) {
            addCriterion("ret_2y_a >=", value, "ret2yA");
            return (Criteria) this;
        }

        public Criteria andRet2yALessThan(Double value) {
            addCriterion("ret_2y_a <", value, "ret2yA");
            return (Criteria) this;
        }

        public Criteria andRet2yALessThanOrEqualTo(Double value) {
            addCriterion("ret_2y_a <=", value, "ret2yA");
            return (Criteria) this;
        }

        public Criteria andRet2yAIn(List<Double> values) {
            addCriterion("ret_2y_a in", values, "ret2yA");
            return (Criteria) this;
        }

        public Criteria andRet2yANotIn(List<Double> values) {
            addCriterion("ret_2y_a not in", values, "ret2yA");
            return (Criteria) this;
        }

        public Criteria andRet2yABetween(Double value1, Double value2) {
            addCriterion("ret_2y_a between", value1, value2, "ret2yA");
            return (Criteria) this;
        }

        public Criteria andRet2yANotBetween(Double value1, Double value2) {
            addCriterion("ret_2y_a not between", value1, value2, "ret2yA");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1IsNull() {
            addCriterion("ret_2y_bm1_ is null");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1IsNotNull() {
            addCriterion("ret_2y_bm1_ is not null");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1EqualTo(Double value) {
            addCriterion("ret_2y_bm1_ =", value, "ret2yBm1");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1NotEqualTo(Double value) {
            addCriterion("ret_2y_bm1_ <>", value, "ret2yBm1");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1GreaterThan(Double value) {
            addCriterion("ret_2y_bm1_ >", value, "ret2yBm1");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1GreaterThanOrEqualTo(Double value) {
            addCriterion("ret_2y_bm1_ >=", value, "ret2yBm1");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1LessThan(Double value) {
            addCriterion("ret_2y_bm1_ <", value, "ret2yBm1");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1LessThanOrEqualTo(Double value) {
            addCriterion("ret_2y_bm1_ <=", value, "ret2yBm1");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1In(List<Double> values) {
            addCriterion("ret_2y_bm1_ in", values, "ret2yBm1");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1NotIn(List<Double> values) {
            addCriterion("ret_2y_bm1_ not in", values, "ret2yBm1");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1Between(Double value1, Double value2) {
            addCriterion("ret_2y_bm1_ between", value1, value2, "ret2yBm1");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1NotBetween(Double value1, Double value2) {
            addCriterion("ret_2y_bm1_ not between", value1, value2, "ret2yBm1");
            return (Criteria) this;
        }

        public Criteria andRet3yIsNull() {
            addCriterion("ret_3y is null");
            return (Criteria) this;
        }

        public Criteria andRet3yIsNotNull() {
            addCriterion("ret_3y is not null");
            return (Criteria) this;
        }

        public Criteria andRet3yEqualTo(Double value) {
            addCriterion("ret_3y =", value, "ret3y");
            return (Criteria) this;
        }

        public Criteria andRet3yNotEqualTo(Double value) {
            addCriterion("ret_3y <>", value, "ret3y");
            return (Criteria) this;
        }

        public Criteria andRet3yGreaterThan(Double value) {
            addCriterion("ret_3y >", value, "ret3y");
            return (Criteria) this;
        }

        public Criteria andRet3yGreaterThanOrEqualTo(Double value) {
            addCriterion("ret_3y >=", value, "ret3y");
            return (Criteria) this;
        }

        public Criteria andRet3yLessThan(Double value) {
            addCriterion("ret_3y <", value, "ret3y");
            return (Criteria) this;
        }

        public Criteria andRet3yLessThanOrEqualTo(Double value) {
            addCriterion("ret_3y <=", value, "ret3y");
            return (Criteria) this;
        }

        public Criteria andRet3yIn(List<Double> values) {
            addCriterion("ret_3y in", values, "ret3y");
            return (Criteria) this;
        }

        public Criteria andRet3yNotIn(List<Double> values) {
            addCriterion("ret_3y not in", values, "ret3y");
            return (Criteria) this;
        }

        public Criteria andRet3yBetween(Double value1, Double value2) {
            addCriterion("ret_3y between", value1, value2, "ret3y");
            return (Criteria) this;
        }

        public Criteria andRet3yNotBetween(Double value1, Double value2) {
            addCriterion("ret_3y not between", value1, value2, "ret3y");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1IsNull() {
            addCriterion("ret_3y_bm1 is null");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1IsNotNull() {
            addCriterion("ret_3y_bm1 is not null");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1EqualTo(Double value) {
            addCriterion("ret_3y_bm1 =", value, "ret3yBm1");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1NotEqualTo(Double value) {
            addCriterion("ret_3y_bm1 <>", value, "ret3yBm1");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1GreaterThan(Double value) {
            addCriterion("ret_3y_bm1 >", value, "ret3yBm1");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1GreaterThanOrEqualTo(Double value) {
            addCriterion("ret_3y_bm1 >=", value, "ret3yBm1");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1LessThan(Double value) {
            addCriterion("ret_3y_bm1 <", value, "ret3yBm1");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1LessThanOrEqualTo(Double value) {
            addCriterion("ret_3y_bm1 <=", value, "ret3yBm1");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1In(List<Double> values) {
            addCriterion("ret_3y_bm1 in", values, "ret3yBm1");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1NotIn(List<Double> values) {
            addCriterion("ret_3y_bm1 not in", values, "ret3yBm1");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1Between(Double value1, Double value2) {
            addCriterion("ret_3y_bm1 between", value1, value2, "ret3yBm1");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1NotBetween(Double value1, Double value2) {
            addCriterion("ret_3y_bm1 not between", value1, value2, "ret3yBm1");
            return (Criteria) this;
        }

        public Criteria andRet3yAIsNull() {
            addCriterion("ret_3y_a is null");
            return (Criteria) this;
        }

        public Criteria andRet3yAIsNotNull() {
            addCriterion("ret_3y_a is not null");
            return (Criteria) this;
        }

        public Criteria andRet3yAEqualTo(Double value) {
            addCriterion("ret_3y_a =", value, "ret3yA");
            return (Criteria) this;
        }

        public Criteria andRet3yANotEqualTo(Double value) {
            addCriterion("ret_3y_a <>", value, "ret3yA");
            return (Criteria) this;
        }

        public Criteria andRet3yAGreaterThan(Double value) {
            addCriterion("ret_3y_a >", value, "ret3yA");
            return (Criteria) this;
        }

        public Criteria andRet3yAGreaterThanOrEqualTo(Double value) {
            addCriterion("ret_3y_a >=", value, "ret3yA");
            return (Criteria) this;
        }

        public Criteria andRet3yALessThan(Double value) {
            addCriterion("ret_3y_a <", value, "ret3yA");
            return (Criteria) this;
        }

        public Criteria andRet3yALessThanOrEqualTo(Double value) {
            addCriterion("ret_3y_a <=", value, "ret3yA");
            return (Criteria) this;
        }

        public Criteria andRet3yAIn(List<Double> values) {
            addCriterion("ret_3y_a in", values, "ret3yA");
            return (Criteria) this;
        }

        public Criteria andRet3yANotIn(List<Double> values) {
            addCriterion("ret_3y_a not in", values, "ret3yA");
            return (Criteria) this;
        }

        public Criteria andRet3yABetween(Double value1, Double value2) {
            addCriterion("ret_3y_a between", value1, value2, "ret3yA");
            return (Criteria) this;
        }

        public Criteria andRet3yANotBetween(Double value1, Double value2) {
            addCriterion("ret_3y_a not between", value1, value2, "ret3yA");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1IsNull() {
            addCriterion("ret_3y_bm1_ is null");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1IsNotNull() {
            addCriterion("ret_3y_bm1_ is not null");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1EqualTo(Double value) {
            addCriterion("ret_3y_bm1_ =", value, "ret3yBm1");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1NotEqualTo(Double value) {
            addCriterion("ret_3y_bm1_ <>", value, "ret3yBm1");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1GreaterThan(Double value) {
            addCriterion("ret_3y_bm1_ >", value, "ret3yBm1");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1GreaterThanOrEqualTo(Double value) {
            addCriterion("ret_3y_bm1_ >=", value, "ret3yBm1");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1LessThan(Double value) {
            addCriterion("ret_3y_bm1_ <", value, "ret3yBm1");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1LessThanOrEqualTo(Double value) {
            addCriterion("ret_3y_bm1_ <=", value, "ret3yBm1");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1In(List<Double> values) {
            addCriterion("ret_3y_bm1_ in", values, "ret3yBm1");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1NotIn(List<Double> values) {
            addCriterion("ret_3y_bm1_ not in", values, "ret3yBm1");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1Between(Double value1, Double value2) {
            addCriterion("ret_3y_bm1_ between", value1, value2, "ret3yBm1");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1NotBetween(Double value1, Double value2) {
            addCriterion("ret_3y_bm1_ not between", value1, value2, "ret3yBm1");
            return (Criteria) this;
        }

        public Criteria andRet4yIsNull() {
            addCriterion("ret_4y is null");
            return (Criteria) this;
        }

        public Criteria andRet4yIsNotNull() {
            addCriterion("ret_4y is not null");
            return (Criteria) this;
        }

        public Criteria andRet4yEqualTo(Double value) {
            addCriterion("ret_4y =", value, "ret4y");
            return (Criteria) this;
        }

        public Criteria andRet4yNotEqualTo(Double value) {
            addCriterion("ret_4y <>", value, "ret4y");
            return (Criteria) this;
        }

        public Criteria andRet4yGreaterThan(Double value) {
            addCriterion("ret_4y >", value, "ret4y");
            return (Criteria) this;
        }

        public Criteria andRet4yGreaterThanOrEqualTo(Double value) {
            addCriterion("ret_4y >=", value, "ret4y");
            return (Criteria) this;
        }

        public Criteria andRet4yLessThan(Double value) {
            addCriterion("ret_4y <", value, "ret4y");
            return (Criteria) this;
        }

        public Criteria andRet4yLessThanOrEqualTo(Double value) {
            addCriterion("ret_4y <=", value, "ret4y");
            return (Criteria) this;
        }

        public Criteria andRet4yIn(List<Double> values) {
            addCriterion("ret_4y in", values, "ret4y");
            return (Criteria) this;
        }

        public Criteria andRet4yNotIn(List<Double> values) {
            addCriterion("ret_4y not in", values, "ret4y");
            return (Criteria) this;
        }

        public Criteria andRet4yBetween(Double value1, Double value2) {
            addCriterion("ret_4y between", value1, value2, "ret4y");
            return (Criteria) this;
        }

        public Criteria andRet4yNotBetween(Double value1, Double value2) {
            addCriterion("ret_4y not between", value1, value2, "ret4y");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1IsNull() {
            addCriterion("ret_4y_bm1 is null");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1IsNotNull() {
            addCriterion("ret_4y_bm1 is not null");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1EqualTo(Double value) {
            addCriterion("ret_4y_bm1 =", value, "ret4yBm1");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1NotEqualTo(Double value) {
            addCriterion("ret_4y_bm1 <>", value, "ret4yBm1");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1GreaterThan(Double value) {
            addCriterion("ret_4y_bm1 >", value, "ret4yBm1");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1GreaterThanOrEqualTo(Double value) {
            addCriterion("ret_4y_bm1 >=", value, "ret4yBm1");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1LessThan(Double value) {
            addCriterion("ret_4y_bm1 <", value, "ret4yBm1");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1LessThanOrEqualTo(Double value) {
            addCriterion("ret_4y_bm1 <=", value, "ret4yBm1");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1In(List<Double> values) {
            addCriterion("ret_4y_bm1 in", values, "ret4yBm1");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1NotIn(List<Double> values) {
            addCriterion("ret_4y_bm1 not in", values, "ret4yBm1");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1Between(Double value1, Double value2) {
            addCriterion("ret_4y_bm1 between", value1, value2, "ret4yBm1");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1NotBetween(Double value1, Double value2) {
            addCriterion("ret_4y_bm1 not between", value1, value2, "ret4yBm1");
            return (Criteria) this;
        }

        public Criteria andRet4yAIsNull() {
            addCriterion("ret_4y_a is null");
            return (Criteria) this;
        }

        public Criteria andRet4yAIsNotNull() {
            addCriterion("ret_4y_a is not null");
            return (Criteria) this;
        }

        public Criteria andRet4yAEqualTo(Double value) {
            addCriterion("ret_4y_a =", value, "ret4yA");
            return (Criteria) this;
        }

        public Criteria andRet4yANotEqualTo(Double value) {
            addCriterion("ret_4y_a <>", value, "ret4yA");
            return (Criteria) this;
        }

        public Criteria andRet4yAGreaterThan(Double value) {
            addCriterion("ret_4y_a >", value, "ret4yA");
            return (Criteria) this;
        }

        public Criteria andRet4yAGreaterThanOrEqualTo(Double value) {
            addCriterion("ret_4y_a >=", value, "ret4yA");
            return (Criteria) this;
        }

        public Criteria andRet4yALessThan(Double value) {
            addCriterion("ret_4y_a <", value, "ret4yA");
            return (Criteria) this;
        }

        public Criteria andRet4yALessThanOrEqualTo(Double value) {
            addCriterion("ret_4y_a <=", value, "ret4yA");
            return (Criteria) this;
        }

        public Criteria andRet4yAIn(List<Double> values) {
            addCriterion("ret_4y_a in", values, "ret4yA");
            return (Criteria) this;
        }

        public Criteria andRet4yANotIn(List<Double> values) {
            addCriterion("ret_4y_a not in", values, "ret4yA");
            return (Criteria) this;
        }

        public Criteria andRet4yABetween(Double value1, Double value2) {
            addCriterion("ret_4y_a between", value1, value2, "ret4yA");
            return (Criteria) this;
        }

        public Criteria andRet4yANotBetween(Double value1, Double value2) {
            addCriterion("ret_4y_a not between", value1, value2, "ret4yA");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1IsNull() {
            addCriterion("ret_4y_bm1_ is null");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1IsNotNull() {
            addCriterion("ret_4y_bm1_ is not null");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1EqualTo(Double value) {
            addCriterion("ret_4y_bm1_ =", value, "ret4yBm1");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1NotEqualTo(Double value) {
            addCriterion("ret_4y_bm1_ <>", value, "ret4yBm1");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1GreaterThan(Double value) {
            addCriterion("ret_4y_bm1_ >", value, "ret4yBm1");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1GreaterThanOrEqualTo(Double value) {
            addCriterion("ret_4y_bm1_ >=", value, "ret4yBm1");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1LessThan(Double value) {
            addCriterion("ret_4y_bm1_ <", value, "ret4yBm1");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1LessThanOrEqualTo(Double value) {
            addCriterion("ret_4y_bm1_ <=", value, "ret4yBm1");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1In(List<Double> values) {
            addCriterion("ret_4y_bm1_ in", values, "ret4yBm1");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1NotIn(List<Double> values) {
            addCriterion("ret_4y_bm1_ not in", values, "ret4yBm1");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1Between(Double value1, Double value2) {
            addCriterion("ret_4y_bm1_ between", value1, value2, "ret4yBm1");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1NotBetween(Double value1, Double value2) {
            addCriterion("ret_4y_bm1_ not between", value1, value2, "ret4yBm1");
            return (Criteria) this;
        }

        public Criteria andRet5yIsNull() {
            addCriterion("ret_5y is null");
            return (Criteria) this;
        }

        public Criteria andRet5yIsNotNull() {
            addCriterion("ret_5y is not null");
            return (Criteria) this;
        }

        public Criteria andRet5yEqualTo(Double value) {
            addCriterion("ret_5y =", value, "ret5y");
            return (Criteria) this;
        }

        public Criteria andRet5yNotEqualTo(Double value) {
            addCriterion("ret_5y <>", value, "ret5y");
            return (Criteria) this;
        }

        public Criteria andRet5yGreaterThan(Double value) {
            addCriterion("ret_5y >", value, "ret5y");
            return (Criteria) this;
        }

        public Criteria andRet5yGreaterThanOrEqualTo(Double value) {
            addCriterion("ret_5y >=", value, "ret5y");
            return (Criteria) this;
        }

        public Criteria andRet5yLessThan(Double value) {
            addCriterion("ret_5y <", value, "ret5y");
            return (Criteria) this;
        }

        public Criteria andRet5yLessThanOrEqualTo(Double value) {
            addCriterion("ret_5y <=", value, "ret5y");
            return (Criteria) this;
        }

        public Criteria andRet5yIn(List<Double> values) {
            addCriterion("ret_5y in", values, "ret5y");
            return (Criteria) this;
        }

        public Criteria andRet5yNotIn(List<Double> values) {
            addCriterion("ret_5y not in", values, "ret5y");
            return (Criteria) this;
        }

        public Criteria andRet5yBetween(Double value1, Double value2) {
            addCriterion("ret_5y between", value1, value2, "ret5y");
            return (Criteria) this;
        }

        public Criteria andRet5yNotBetween(Double value1, Double value2) {
            addCriterion("ret_5y not between", value1, value2, "ret5y");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1IsNull() {
            addCriterion("ret_5y_bm1 is null");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1IsNotNull() {
            addCriterion("ret_5y_bm1 is not null");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1EqualTo(Double value) {
            addCriterion("ret_5y_bm1 =", value, "ret5yBm1");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1NotEqualTo(Double value) {
            addCriterion("ret_5y_bm1 <>", value, "ret5yBm1");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1GreaterThan(Double value) {
            addCriterion("ret_5y_bm1 >", value, "ret5yBm1");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1GreaterThanOrEqualTo(Double value) {
            addCriterion("ret_5y_bm1 >=", value, "ret5yBm1");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1LessThan(Double value) {
            addCriterion("ret_5y_bm1 <", value, "ret5yBm1");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1LessThanOrEqualTo(Double value) {
            addCriterion("ret_5y_bm1 <=", value, "ret5yBm1");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1In(List<Double> values) {
            addCriterion("ret_5y_bm1 in", values, "ret5yBm1");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1NotIn(List<Double> values) {
            addCriterion("ret_5y_bm1 not in", values, "ret5yBm1");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1Between(Double value1, Double value2) {
            addCriterion("ret_5y_bm1 between", value1, value2, "ret5yBm1");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1NotBetween(Double value1, Double value2) {
            addCriterion("ret_5y_bm1 not between", value1, value2, "ret5yBm1");
            return (Criteria) this;
        }

        public Criteria andRet5yAIsNull() {
            addCriterion("ret_5y_a is null");
            return (Criteria) this;
        }

        public Criteria andRet5yAIsNotNull() {
            addCriterion("ret_5y_a is not null");
            return (Criteria) this;
        }

        public Criteria andRet5yAEqualTo(Double value) {
            addCriterion("ret_5y_a =", value, "ret5yA");
            return (Criteria) this;
        }

        public Criteria andRet5yANotEqualTo(Double value) {
            addCriterion("ret_5y_a <>", value, "ret5yA");
            return (Criteria) this;
        }

        public Criteria andRet5yAGreaterThan(Double value) {
            addCriterion("ret_5y_a >", value, "ret5yA");
            return (Criteria) this;
        }

        public Criteria andRet5yAGreaterThanOrEqualTo(Double value) {
            addCriterion("ret_5y_a >=", value, "ret5yA");
            return (Criteria) this;
        }

        public Criteria andRet5yALessThan(Double value) {
            addCriterion("ret_5y_a <", value, "ret5yA");
            return (Criteria) this;
        }

        public Criteria andRet5yALessThanOrEqualTo(Double value) {
            addCriterion("ret_5y_a <=", value, "ret5yA");
            return (Criteria) this;
        }

        public Criteria andRet5yAIn(List<Double> values) {
            addCriterion("ret_5y_a in", values, "ret5yA");
            return (Criteria) this;
        }

        public Criteria andRet5yANotIn(List<Double> values) {
            addCriterion("ret_5y_a not in", values, "ret5yA");
            return (Criteria) this;
        }

        public Criteria andRet5yABetween(Double value1, Double value2) {
            addCriterion("ret_5y_a between", value1, value2, "ret5yA");
            return (Criteria) this;
        }

        public Criteria andRet5yANotBetween(Double value1, Double value2) {
            addCriterion("ret_5y_a not between", value1, value2, "ret5yA");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1IsNull() {
            addCriterion("ret_5y_bm1_ is null");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1IsNotNull() {
            addCriterion("ret_5y_bm1_ is not null");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1EqualTo(Double value) {
            addCriterion("ret_5y_bm1_ =", value, "ret5yBm1");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1NotEqualTo(Double value) {
            addCriterion("ret_5y_bm1_ <>", value, "ret5yBm1");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1GreaterThan(Double value) {
            addCriterion("ret_5y_bm1_ >", value, "ret5yBm1");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1GreaterThanOrEqualTo(Double value) {
            addCriterion("ret_5y_bm1_ >=", value, "ret5yBm1");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1LessThan(Double value) {
            addCriterion("ret_5y_bm1_ <", value, "ret5yBm1");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1LessThanOrEqualTo(Double value) {
            addCriterion("ret_5y_bm1_ <=", value, "ret5yBm1");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1In(List<Double> values) {
            addCriterion("ret_5y_bm1_ in", values, "ret5yBm1");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1NotIn(List<Double> values) {
            addCriterion("ret_5y_bm1_ not in", values, "ret5yBm1");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1Between(Double value1, Double value2) {
            addCriterion("ret_5y_bm1_ between", value1, value2, "ret5yBm1");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1NotBetween(Double value1, Double value2) {
            addCriterion("ret_5y_bm1_ not between", value1, value2, "ret5yBm1");
            return (Criteria) this;
        }

        public Criteria andRet10yIsNull() {
            addCriterion("ret_10y is null");
            return (Criteria) this;
        }

        public Criteria andRet10yIsNotNull() {
            addCriterion("ret_10y is not null");
            return (Criteria) this;
        }

        public Criteria andRet10yEqualTo(Double value) {
            addCriterion("ret_10y =", value, "ret10y");
            return (Criteria) this;
        }

        public Criteria andRet10yNotEqualTo(Double value) {
            addCriterion("ret_10y <>", value, "ret10y");
            return (Criteria) this;
        }

        public Criteria andRet10yGreaterThan(Double value) {
            addCriterion("ret_10y >", value, "ret10y");
            return (Criteria) this;
        }

        public Criteria andRet10yGreaterThanOrEqualTo(Double value) {
            addCriterion("ret_10y >=", value, "ret10y");
            return (Criteria) this;
        }

        public Criteria andRet10yLessThan(Double value) {
            addCriterion("ret_10y <", value, "ret10y");
            return (Criteria) this;
        }

        public Criteria andRet10yLessThanOrEqualTo(Double value) {
            addCriterion("ret_10y <=", value, "ret10y");
            return (Criteria) this;
        }

        public Criteria andRet10yIn(List<Double> values) {
            addCriterion("ret_10y in", values, "ret10y");
            return (Criteria) this;
        }

        public Criteria andRet10yNotIn(List<Double> values) {
            addCriterion("ret_10y not in", values, "ret10y");
            return (Criteria) this;
        }

        public Criteria andRet10yBetween(Double value1, Double value2) {
            addCriterion("ret_10y between", value1, value2, "ret10y");
            return (Criteria) this;
        }

        public Criteria andRet10yNotBetween(Double value1, Double value2) {
            addCriterion("ret_10y not between", value1, value2, "ret10y");
            return (Criteria) this;
        }

        public Criteria andRet10yBm1IsNull() {
            addCriterion("ret_10y_bm1 is null");
            return (Criteria) this;
        }

        public Criteria andRet10yBm1IsNotNull() {
            addCriterion("ret_10y_bm1 is not null");
            return (Criteria) this;
        }

        public Criteria andRet10yBm1EqualTo(Double value) {
            addCriterion("ret_10y_bm1 =", value, "ret10yBm1");
            return (Criteria) this;
        }

        public Criteria andRet10yBm1NotEqualTo(Double value) {
            addCriterion("ret_10y_bm1 <>", value, "ret10yBm1");
            return (Criteria) this;
        }

        public Criteria andRet10yBm1GreaterThan(Double value) {
            addCriterion("ret_10y_bm1 >", value, "ret10yBm1");
            return (Criteria) this;
        }

        public Criteria andRet10yBm1GreaterThanOrEqualTo(Double value) {
            addCriterion("ret_10y_bm1 >=", value, "ret10yBm1");
            return (Criteria) this;
        }

        public Criteria andRet10yBm1LessThan(Double value) {
            addCriterion("ret_10y_bm1 <", value, "ret10yBm1");
            return (Criteria) this;
        }

        public Criteria andRet10yBm1LessThanOrEqualTo(Double value) {
            addCriterion("ret_10y_bm1 <=", value, "ret10yBm1");
            return (Criteria) this;
        }

        public Criteria andRet10yBm1In(List<Double> values) {
            addCriterion("ret_10y_bm1 in", values, "ret10yBm1");
            return (Criteria) this;
        }

        public Criteria andRet10yBm1NotIn(List<Double> values) {
            addCriterion("ret_10y_bm1 not in", values, "ret10yBm1");
            return (Criteria) this;
        }

        public Criteria andRet10yBm1Between(Double value1, Double value2) {
            addCriterion("ret_10y_bm1 between", value1, value2, "ret10yBm1");
            return (Criteria) this;
        }

        public Criteria andRet10yBm1NotBetween(Double value1, Double value2) {
            addCriterion("ret_10y_bm1 not between", value1, value2, "ret10yBm1");
            return (Criteria) this;
        }

        public Criteria andRet10yAIsNull() {
            addCriterion("ret_10y_a is null");
            return (Criteria) this;
        }

        public Criteria andRet10yAIsNotNull() {
            addCriterion("ret_10y_a is not null");
            return (Criteria) this;
        }

        public Criteria andRet10yAEqualTo(Double value) {
            addCriterion("ret_10y_a =", value, "ret10yA");
            return (Criteria) this;
        }

        public Criteria andRet10yANotEqualTo(Double value) {
            addCriterion("ret_10y_a <>", value, "ret10yA");
            return (Criteria) this;
        }

        public Criteria andRet10yAGreaterThan(Double value) {
            addCriterion("ret_10y_a >", value, "ret10yA");
            return (Criteria) this;
        }

        public Criteria andRet10yAGreaterThanOrEqualTo(Double value) {
            addCriterion("ret_10y_a >=", value, "ret10yA");
            return (Criteria) this;
        }

        public Criteria andRet10yALessThan(Double value) {
            addCriterion("ret_10y_a <", value, "ret10yA");
            return (Criteria) this;
        }

        public Criteria andRet10yALessThanOrEqualTo(Double value) {
            addCriterion("ret_10y_a <=", value, "ret10yA");
            return (Criteria) this;
        }

        public Criteria andRet10yAIn(List<Double> values) {
            addCriterion("ret_10y_a in", values, "ret10yA");
            return (Criteria) this;
        }

        public Criteria andRet10yANotIn(List<Double> values) {
            addCriterion("ret_10y_a not in", values, "ret10yA");
            return (Criteria) this;
        }

        public Criteria andRet10yABetween(Double value1, Double value2) {
            addCriterion("ret_10y_a between", value1, value2, "ret10yA");
            return (Criteria) this;
        }

        public Criteria andRet10yANotBetween(Double value1, Double value2) {
            addCriterion("ret_10y_a not between", value1, value2, "ret10yA");
            return (Criteria) this;
        }

        public Criteria andRet10yBm11IsNull() {
            addCriterion("ret_10y_bm11 is null");
            return (Criteria) this;
        }

        public Criteria andRet10yBm11IsNotNull() {
            addCriterion("ret_10y_bm11 is not null");
            return (Criteria) this;
        }

        public Criteria andRet10yBm11EqualTo(Double value) {
            addCriterion("ret_10y_bm11 =", value, "ret10yBm11");
            return (Criteria) this;
        }

        public Criteria andRet10yBm11NotEqualTo(Double value) {
            addCriterion("ret_10y_bm11 <>", value, "ret10yBm11");
            return (Criteria) this;
        }

        public Criteria andRet10yBm11GreaterThan(Double value) {
            addCriterion("ret_10y_bm11 >", value, "ret10yBm11");
            return (Criteria) this;
        }

        public Criteria andRet10yBm11GreaterThanOrEqualTo(Double value) {
            addCriterion("ret_10y_bm11 >=", value, "ret10yBm11");
            return (Criteria) this;
        }

        public Criteria andRet10yBm11LessThan(Double value) {
            addCriterion("ret_10y_bm11 <", value, "ret10yBm11");
            return (Criteria) this;
        }

        public Criteria andRet10yBm11LessThanOrEqualTo(Double value) {
            addCriterion("ret_10y_bm11 <=", value, "ret10yBm11");
            return (Criteria) this;
        }

        public Criteria andRet10yBm11In(List<Double> values) {
            addCriterion("ret_10y_bm11 in", values, "ret10yBm11");
            return (Criteria) this;
        }

        public Criteria andRet10yBm11NotIn(List<Double> values) {
            addCriterion("ret_10y_bm11 not in", values, "ret10yBm11");
            return (Criteria) this;
        }

        public Criteria andRet10yBm11Between(Double value1, Double value2) {
            addCriterion("ret_10y_bm11 between", value1, value2, "ret10yBm11");
            return (Criteria) this;
        }

        public Criteria andRet10yBm11NotBetween(Double value1, Double value2) {
            addCriterion("ret_10y_bm11 not between", value1, value2, "ret10yBm11");
            return (Criteria) this;
        }

        public Criteria andRetYtdIsNull() {
            addCriterion("ret_ytd is null");
            return (Criteria) this;
        }

        public Criteria andRetYtdIsNotNull() {
            addCriterion("ret_ytd is not null");
            return (Criteria) this;
        }

        public Criteria andRetYtdEqualTo(Double value) {
            addCriterion("ret_ytd =", value, "retYtd");
            return (Criteria) this;
        }

        public Criteria andRetYtdNotEqualTo(Double value) {
            addCriterion("ret_ytd <>", value, "retYtd");
            return (Criteria) this;
        }

        public Criteria andRetYtdGreaterThan(Double value) {
            addCriterion("ret_ytd >", value, "retYtd");
            return (Criteria) this;
        }

        public Criteria andRetYtdGreaterThanOrEqualTo(Double value) {
            addCriterion("ret_ytd >=", value, "retYtd");
            return (Criteria) this;
        }

        public Criteria andRetYtdLessThan(Double value) {
            addCriterion("ret_ytd <", value, "retYtd");
            return (Criteria) this;
        }

        public Criteria andRetYtdLessThanOrEqualTo(Double value) {
            addCriterion("ret_ytd <=", value, "retYtd");
            return (Criteria) this;
        }

        public Criteria andRetYtdIn(List<Double> values) {
            addCriterion("ret_ytd in", values, "retYtd");
            return (Criteria) this;
        }

        public Criteria andRetYtdNotIn(List<Double> values) {
            addCriterion("ret_ytd not in", values, "retYtd");
            return (Criteria) this;
        }

        public Criteria andRetYtdBetween(Double value1, Double value2) {
            addCriterion("ret_ytd between", value1, value2, "retYtd");
            return (Criteria) this;
        }

        public Criteria andRetYtdNotBetween(Double value1, Double value2) {
            addCriterion("ret_ytd not between", value1, value2, "retYtd");
            return (Criteria) this;
        }

        public Criteria andRetYtdBm1IsNull() {
            addCriterion("ret_ytd_bm1 is null");
            return (Criteria) this;
        }

        public Criteria andRetYtdBm1IsNotNull() {
            addCriterion("ret_ytd_bm1 is not null");
            return (Criteria) this;
        }

        public Criteria andRetYtdBm1EqualTo(Double value) {
            addCriterion("ret_ytd_bm1 =", value, "retYtdBm1");
            return (Criteria) this;
        }

        public Criteria andRetYtdBm1NotEqualTo(Double value) {
            addCriterion("ret_ytd_bm1 <>", value, "retYtdBm1");
            return (Criteria) this;
        }

        public Criteria andRetYtdBm1GreaterThan(Double value) {
            addCriterion("ret_ytd_bm1 >", value, "retYtdBm1");
            return (Criteria) this;
        }

        public Criteria andRetYtdBm1GreaterThanOrEqualTo(Double value) {
            addCriterion("ret_ytd_bm1 >=", value, "retYtdBm1");
            return (Criteria) this;
        }

        public Criteria andRetYtdBm1LessThan(Double value) {
            addCriterion("ret_ytd_bm1 <", value, "retYtdBm1");
            return (Criteria) this;
        }

        public Criteria andRetYtdBm1LessThanOrEqualTo(Double value) {
            addCriterion("ret_ytd_bm1 <=", value, "retYtdBm1");
            return (Criteria) this;
        }

        public Criteria andRetYtdBm1In(List<Double> values) {
            addCriterion("ret_ytd_bm1 in", values, "retYtdBm1");
            return (Criteria) this;
        }

        public Criteria andRetYtdBm1NotIn(List<Double> values) {
            addCriterion("ret_ytd_bm1 not in", values, "retYtdBm1");
            return (Criteria) this;
        }

        public Criteria andRetYtdBm1Between(Double value1, Double value2) {
            addCriterion("ret_ytd_bm1 between", value1, value2, "retYtdBm1");
            return (Criteria) this;
        }

        public Criteria andRetYtdBm1NotBetween(Double value1, Double value2) {
            addCriterion("ret_ytd_bm1 not between", value1, value2, "retYtdBm1");
            return (Criteria) this;
        }

        public Criteria andRetIncepIsNull() {
            addCriterion("ret_incep is null");
            return (Criteria) this;
        }

        public Criteria andRetIncepIsNotNull() {
            addCriterion("ret_incep is not null");
            return (Criteria) this;
        }

        public Criteria andRetIncepEqualTo(Double value) {
            addCriterion("ret_incep =", value, "retIncep");
            return (Criteria) this;
        }

        public Criteria andRetIncepNotEqualTo(Double value) {
            addCriterion("ret_incep <>", value, "retIncep");
            return (Criteria) this;
        }

        public Criteria andRetIncepGreaterThan(Double value) {
            addCriterion("ret_incep >", value, "retIncep");
            return (Criteria) this;
        }

        public Criteria andRetIncepGreaterThanOrEqualTo(Double value) {
            addCriterion("ret_incep >=", value, "retIncep");
            return (Criteria) this;
        }

        public Criteria andRetIncepLessThan(Double value) {
            addCriterion("ret_incep <", value, "retIncep");
            return (Criteria) this;
        }

        public Criteria andRetIncepLessThanOrEqualTo(Double value) {
            addCriterion("ret_incep <=", value, "retIncep");
            return (Criteria) this;
        }

        public Criteria andRetIncepIn(List<Double> values) {
            addCriterion("ret_incep in", values, "retIncep");
            return (Criteria) this;
        }

        public Criteria andRetIncepNotIn(List<Double> values) {
            addCriterion("ret_incep not in", values, "retIncep");
            return (Criteria) this;
        }

        public Criteria andRetIncepBetween(Double value1, Double value2) {
            addCriterion("ret_incep between", value1, value2, "retIncep");
            return (Criteria) this;
        }

        public Criteria andRetIncepNotBetween(Double value1, Double value2) {
            addCriterion("ret_incep not between", value1, value2, "retIncep");
            return (Criteria) this;
        }

        public Criteria andRetIncepBIsNull() {
            addCriterion("ret_incep_b is null");
            return (Criteria) this;
        }

        public Criteria andRetIncepBIsNotNull() {
            addCriterion("ret_incep_b is not null");
            return (Criteria) this;
        }

        public Criteria andRetIncepBEqualTo(Double value) {
            addCriterion("ret_incep_b =", value, "retIncepB");
            return (Criteria) this;
        }

        public Criteria andRetIncepBNotEqualTo(Double value) {
            addCriterion("ret_incep_b <>", value, "retIncepB");
            return (Criteria) this;
        }

        public Criteria andRetIncepBGreaterThan(Double value) {
            addCriterion("ret_incep_b >", value, "retIncepB");
            return (Criteria) this;
        }

        public Criteria andRetIncepBGreaterThanOrEqualTo(Double value) {
            addCriterion("ret_incep_b >=", value, "retIncepB");
            return (Criteria) this;
        }

        public Criteria andRetIncepBLessThan(Double value) {
            addCriterion("ret_incep_b <", value, "retIncepB");
            return (Criteria) this;
        }

        public Criteria andRetIncepBLessThanOrEqualTo(Double value) {
            addCriterion("ret_incep_b <=", value, "retIncepB");
            return (Criteria) this;
        }

        public Criteria andRetIncepBIn(List<Double> values) {
            addCriterion("ret_incep_b in", values, "retIncepB");
            return (Criteria) this;
        }

        public Criteria andRetIncepBNotIn(List<Double> values) {
            addCriterion("ret_incep_b not in", values, "retIncepB");
            return (Criteria) this;
        }

        public Criteria andRetIncepBBetween(Double value1, Double value2) {
            addCriterion("ret_incep_b between", value1, value2, "retIncepB");
            return (Criteria) this;
        }

        public Criteria andRetIncepBNotBetween(Double value1, Double value2) {
            addCriterion("ret_incep_b not between", value1, value2, "retIncepB");
            return (Criteria) this;
        }

        public Criteria andRetIncepAIsNull() {
            addCriterion("ret_incep_a is null");
            return (Criteria) this;
        }

        public Criteria andRetIncepAIsNotNull() {
            addCriterion("ret_incep_a is not null");
            return (Criteria) this;
        }

        public Criteria andRetIncepAEqualTo(Double value) {
            addCriterion("ret_incep_a =", value, "retIncepA");
            return (Criteria) this;
        }

        public Criteria andRetIncepANotEqualTo(Double value) {
            addCriterion("ret_incep_a <>", value, "retIncepA");
            return (Criteria) this;
        }

        public Criteria andRetIncepAGreaterThan(Double value) {
            addCriterion("ret_incep_a >", value, "retIncepA");
            return (Criteria) this;
        }

        public Criteria andRetIncepAGreaterThanOrEqualTo(Double value) {
            addCriterion("ret_incep_a >=", value, "retIncepA");
            return (Criteria) this;
        }

        public Criteria andRetIncepALessThan(Double value) {
            addCriterion("ret_incep_a <", value, "retIncepA");
            return (Criteria) this;
        }

        public Criteria andRetIncepALessThanOrEqualTo(Double value) {
            addCriterion("ret_incep_a <=", value, "retIncepA");
            return (Criteria) this;
        }

        public Criteria andRetIncepAIn(List<Double> values) {
            addCriterion("ret_incep_a in", values, "retIncepA");
            return (Criteria) this;
        }

        public Criteria andRetIncepANotIn(List<Double> values) {
            addCriterion("ret_incep_a not in", values, "retIncepA");
            return (Criteria) this;
        }

        public Criteria andRetIncepABetween(Double value1, Double value2) {
            addCriterion("ret_incep_a between", value1, value2, "retIncepA");
            return (Criteria) this;
        }

        public Criteria andRetIncepANotBetween(Double value1, Double value2) {
            addCriterion("ret_incep_a not between", value1, value2, "retIncepA");
            return (Criteria) this;
        }

        public Criteria andRetIncepB1IsNull() {
            addCriterion("ret_incep_b1 is null");
            return (Criteria) this;
        }

        public Criteria andRetIncepB1IsNotNull() {
            addCriterion("ret_incep_b1 is not null");
            return (Criteria) this;
        }

        public Criteria andRetIncepB1EqualTo(Double value) {
            addCriterion("ret_incep_b1 =", value, "retIncepB1");
            return (Criteria) this;
        }

        public Criteria andRetIncepB1NotEqualTo(Double value) {
            addCriterion("ret_incep_b1 <>", value, "retIncepB1");
            return (Criteria) this;
        }

        public Criteria andRetIncepB1GreaterThan(Double value) {
            addCriterion("ret_incep_b1 >", value, "retIncepB1");
            return (Criteria) this;
        }

        public Criteria andRetIncepB1GreaterThanOrEqualTo(Double value) {
            addCriterion("ret_incep_b1 >=", value, "retIncepB1");
            return (Criteria) this;
        }

        public Criteria andRetIncepB1LessThan(Double value) {
            addCriterion("ret_incep_b1 <", value, "retIncepB1");
            return (Criteria) this;
        }

        public Criteria andRetIncepB1LessThanOrEqualTo(Double value) {
            addCriterion("ret_incep_b1 <=", value, "retIncepB1");
            return (Criteria) this;
        }

        public Criteria andRetIncepB1In(List<Double> values) {
            addCriterion("ret_incep_b1 in", values, "retIncepB1");
            return (Criteria) this;
        }

        public Criteria andRetIncepB1NotIn(List<Double> values) {
            addCriterion("ret_incep_b1 not in", values, "retIncepB1");
            return (Criteria) this;
        }

        public Criteria andRetIncepB1Between(Double value1, Double value2) {
            addCriterion("ret_incep_b1 between", value1, value2, "retIncepB1");
            return (Criteria) this;
        }

        public Criteria andRetIncepB1NotBetween(Double value1, Double value2) {
            addCriterion("ret_incep_b1 not between", value1, value2, "retIncepB1");
            return (Criteria) this;
        }

        public Criteria andIsvalidIsNull() {
            addCriterion("isvalid is null");
            return (Criteria) this;
        }

        public Criteria andIsvalidIsNotNull() {
            addCriterion("isvalid is not null");
            return (Criteria) this;
        }

        public Criteria andIsvalidEqualTo(Long value) {
            addCriterion("isvalid =", value, "isvalid");
            return (Criteria) this;
        }

        public Criteria andIsvalidNotEqualTo(Long value) {
            addCriterion("isvalid <>", value, "isvalid");
            return (Criteria) this;
        }

        public Criteria andIsvalidGreaterThan(Long value) {
            addCriterion("isvalid >", value, "isvalid");
            return (Criteria) this;
        }

        public Criteria andIsvalidGreaterThanOrEqualTo(Long value) {
            addCriterion("isvalid >=", value, "isvalid");
            return (Criteria) this;
        }

        public Criteria andIsvalidLessThan(Long value) {
            addCriterion("isvalid <", value, "isvalid");
            return (Criteria) this;
        }

        public Criteria andIsvalidLessThanOrEqualTo(Long value) {
            addCriterion("isvalid <=", value, "isvalid");
            return (Criteria) this;
        }

        public Criteria andIsvalidIn(List<Long> values) {
            addCriterion("isvalid in", values, "isvalid");
            return (Criteria) this;
        }

        public Criteria andIsvalidNotIn(List<Long> values) {
            addCriterion("isvalid not in", values, "isvalid");
            return (Criteria) this;
        }

        public Criteria andIsvalidBetween(Long value1, Long value2) {
            addCriterion("isvalid between", value1, value2, "isvalid");
            return (Criteria) this;
        }

        public Criteria andIsvalidNotBetween(Long value1, Long value2) {
            addCriterion("isvalid not between", value1, value2, "isvalid");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeIsNull() {
            addCriterion("updatetime is null");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeIsNotNull() {
            addCriterion("updatetime is not null");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeEqualTo(Date value) {
            addCriterionForJDBCDate("updatetime =", value, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeNotEqualTo(Date value) {
            addCriterionForJDBCDate("updatetime <>", value, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeGreaterThan(Date value) {
            addCriterionForJDBCDate("updatetime >", value, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("updatetime >=", value, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeLessThan(Date value) {
            addCriterionForJDBCDate("updatetime <", value, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("updatetime <=", value, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeIn(List<Date> values) {
            addCriterionForJDBCDate("updatetime in", values, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeNotIn(List<Date> values) {
            addCriterionForJDBCDate("updatetime not in", values, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("updatetime between", value1, value2, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("updatetime not between", value1, value2, "updatetime");
            return (Criteria) this;
        }

        public Criteria andCreatetimeIsNull() {
            addCriterion("createtime is null");
            return (Criteria) this;
        }

        public Criteria andCreatetimeIsNotNull() {
            addCriterion("createtime is not null");
            return (Criteria) this;
        }

        public Criteria andCreatetimeEqualTo(Date value) {
            addCriterionForJDBCDate("createtime =", value, "createtime");
            return (Criteria) this;
        }

        public Criteria andCreatetimeNotEqualTo(Date value) {
            addCriterionForJDBCDate("createtime <>", value, "createtime");
            return (Criteria) this;
        }

        public Criteria andCreatetimeGreaterThan(Date value) {
            addCriterionForJDBCDate("createtime >", value, "createtime");
            return (Criteria) this;
        }

        public Criteria andCreatetimeGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("createtime >=", value, "createtime");
            return (Criteria) this;
        }

        public Criteria andCreatetimeLessThan(Date value) {
            addCriterionForJDBCDate("createtime <", value, "createtime");
            return (Criteria) this;
        }

        public Criteria andCreatetimeLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("createtime <=", value, "createtime");
            return (Criteria) this;
        }

        public Criteria andCreatetimeIn(List<Date> values) {
            addCriterionForJDBCDate("createtime in", values, "createtime");
            return (Criteria) this;
        }

        public Criteria andCreatetimeNotIn(List<Date> values) {
            addCriterionForJDBCDate("createtime not in", values, "createtime");
            return (Criteria) this;
        }

        public Criteria andCreatetimeBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("createtime between", value1, value2, "createtime");
            return (Criteria) this;
        }

        public Criteria andCreatetimeNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("createtime not between", value1, value2, "createtime");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}